%global eclipse_dropins      %{_datadir}/eclipse/dropins
%global install_loc_plugins  %{eclipse_dropins}/%{name}/eclipse/plugins
%global install_loc_features %{eclipse_dropins}/%{name}/eclipse/features
%global release_tag          %{version}.20130601-0317
%global x_y                  1.4
%global release_dir          releases/%{x_y}/%{release_tag}

Name:           eclipse-m2e-core
Version:        1.4.0
Release:        12%{?dist}
Summary:        Maven integration for Eclipse

Group:          Development/Tools
# Most of components are under EPL, but some of them are licensed under
# ASL 2.0 license.
License:        EPL and ASL 2.0
URL:            http://eclipse.org/m2e/

Source0:        http://git.eclipse.org/c/m2e/m2e-core.git/snapshot/%{release_dir}.tar.bz2

# Add some necessary stuff (mainly requires & imports) to manifests
Patch0:         %{name}-fix-m2e.core-manifest.patch
Patch1:         %{name}-fix-m2e.core.ui-manifest-1.2.0.patch

# AbstractResourceFetcher is now ResourceFetcher (interface)
Patch2:         %{name}-m2e.core-resourcefetcher.patch

# Archetype class is now ArchetypeManager
Patch3:         %{name}-archetype-archetypemanager.patch

# Method returns collection of ArtifactInfo instances rather than just one
Patch4:         %{name}-artifactinfo-return-type.patch

# Have to specify type here
Patch5:         %{name}-remotearchetypecatalogdialog.patch

# org.eclipse.m2e.launching tries to bundle jars, but they don't seem needed
Patch6:         %{name}-org.eclipse.m2e.launching-build.properties.patch

# Exclude org.jboss.netty from the feature - causes tycho to fail
Patch7:         %{name}-m2e.feature.patch

# In updated lucene in F18, some methods have been renamed
Patch8:         %{name}-lucene-deprecated-methods.patch

# Leaving out the modello version causes a NullPointerException
# See comment 13 on RHBZ #847160
Patch9:         %{name}-m2e.core-modello-version.patch

# API change in maven-indexer 5.1.1
Patch10:        %{name}-indexer-5.1.1.patch

# API change in aether (remove once implemented)
Patch11:        %{name}-new-eclipse-aether-api.patch

# Patch org.eclipse.m2e.launching for maven 3.1.0
# Remove this for 1.5.0 since it's an upstream patch
Patch12:        %{name}-test-maven310-launcher.patch

BuildArch:      noarch

BuildRequires:  aether-api
BuildRequires:  aether-connector-basic
BuildRequires:  aether-transport-wagon
BuildRequires:  aether-transport-http
BuildRequires:  aether-impl
BuildRequires:  aether-spi
BuildRequires:  aether-util
BuildRequires:  apache-commons-cli
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  async-http-client
BuildRequires:  atinject
BuildRequires:  dom4j
BuildRequires:  eclipse-emf >= 2.9.0
BuildRequires:  eclipse-emf-core >= 2.9.0
BuildRequires:  eclipse-jdt >= 4.3.0
BuildRequires:  eclipse-p2-discovery >= 4.2.1
BuildRequires:  eclipse-platform >= 4.3.0
BuildRequires:  eclipse-swt >= 4.3.0
BuildRequires:  eclipse-wtp-common >= 3.5.0-1
BuildRequires:  eclipse-wtp-sourceediting >= 3.5.0-1
BuildRequires:  google-guice >= 3.1.3-9
BuildRequires:  guava
BuildRequires:  hamcrest
BuildRequires:  icu4j-eclipse
BuildRequires:  java-devel
BuildRequires:  jchardet
BuildRequires:  jdom
BuildRequires:  jpackage-utils
BuildRequires:  jsr-305
BuildRequires:  junit
BuildRequires:  lucene
BuildRequires:  lucene-contrib
BuildRequires:  maven-local
BuildRequires:  maven-archetype-catalog
BuildRequires:  maven-archetype-common
BuildRequires:  maven-archetype-descriptor
BuildRequires:  maven-indexer
BuildRequires:  maven-install-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-plugin-build-helper
BuildRequires:  maven-plugin-bundle
BuildRequires:  maven-wagon
BuildRequires:  maven-wagon-ahc
BuildRequires:  netty
BuildRequires:  objectweb-asm
BuildRequires:  plexus-build-api
BuildRequires:  plexus-cipher
BuildRequires:  plexus-classworlds
BuildRequires:  plexus-containers-component-annotations
BuildRequires:  plexus-interpolation
BuildRequires:  plexus-sec-dispatcher
BuildRequires:  plexus-utils
BuildRequires:  plexus-velocity
BuildRequires:  sisu-plexus >= 1:0.0.0-0.4
BuildRequires:  slf4j
BuildRequires:  tycho
BuildRequires:  tycho-extras
BuildRequires:  velocity
BuildRequires:  xbean

Requires:       aether-api
Requires:       aether-connector-basic
Requires:       aether-transport-http
Requires:       aether-transport-wagon
Requires:       aether-impl
Requires:       aether-spi
Requires:       aether-util
Requires:       apache-commons-cli
Requires:       apache-commons-collections
Requires:       apache-commons-io
Requires:       apache-commons-lang
Requires:       async-http-client
Requires:       atinject
Requires:       dom4j
Requires:       eclipse-emf >= 2.9.0
Requires:       eclipse-emf-core >= 2.9.0
Requires:       eclipse-jdt >= 4.3.0
Requires:       eclipse-p2-discovery >= 4.2.1
Requires:       eclipse-platform >= 4.3.0
Requires:       eclipse-swt >= 4.3.0
Requires:       eclipse-wtp-common >= 3.5.0-1
Requires:       eclipse-wtp-sourceediting >= 3.5.0-1
Requires:       google-guice
Requires:       guava
Requires:       hamcrest
Requires:       icu4j-eclipse
Requires:       java
Requires:       jchardet
Requires:       jdom
Requires:       jpackage-utils
Requires:       jsr-305
Requires:       junit
Requires:       lucene
Requires:       lucene-contrib
Requires:       maven
Requires:       maven-archetype-catalog
Requires:       maven-archetype-common
Requires:       maven-archetype-descriptor
Requires:       maven-indexer
Requires:       maven-wagon
Requires:       maven-wagon-ahc
Requires:       netty
Requires:       objectweb-asm
Requires:       plexus-build-api
Requires:       plexus-cipher
Requires:       plexus-classworlds
Requires:       plexus-containers-component-annotations
Requires:       plexus-interpolation
Requires:       plexus-sec-dispatcher
Requires:       plexus-utils
Requires:       plexus-velocity
Requires:       sisu-plexus
Requires:       slf4j
Requires:       velocity
Requires:       xbean


%description
The goal of the m2ec project is to provide a first-class Apache Maven support
in the Eclipse IDE, making it easier to edit Maven's pom.xml, run a build from
the IDE and much more. For Java developers, the very tight integration with JDT
greatly simplifies the consumption of Java artifacts either being hosted on open
source repositories such as Maven Central, or in your in-house Maven repository.

m2e is also a platform that let others provide better integration with
additional Maven plugins (e.g. Android, web development, etc.), and facilitates
the distribution of those extensions through the m2e marketplace.


%package javadoc
Group:          Documentation
Summary:        API documentation for %{name}

%description javadoc
This package contains %{summary}.


%prep
%setup -q -n %{release_dir}

find -name '*.class' -delete
find -name '*.jar' -delete

# Copy license files so they can be installed more easily.
cp -p org.eclipse.m2e.feature/epl-v10.html .
cp -p m2e-maven-runtime/com.ning.async-http-client/src/main/resources/about_files/LICENSE-2.0.txt .

# These don't currently build, but don't seem to be absolutely necessary
%pom_disable_module org.eclipse.m2e.tests.common
%pom_disable_module org.eclipse.m2e.logback.appender
%pom_disable_module org.eclipse.m2e.logback.configuration
%pom_disable_module org.eclipse.m2e.logback.feature
%pom_disable_module org.eclipse.m2e.sdk.feature
%pom_disable_module org.eclipse.m2e.site
%pom_disable_module org.jboss.netty m2e-maven-runtime

# jetty already has OSGI info, so doesn't need to be bundled like it is
%pom_remove_dep org.eclipse.m2e:org.jboss.netty
%pom_add_dep io.netty:netty

# async-http-client already has OSGI info, so doesn't need to be bundled
# adding packaged version as a dep here causes some 'tycholock' problem
%pom_remove_dep org.eclipse.m2e:com.ning.async-http-client

# Use Eclipse Sisu.  Be careful to keep the same dependency scope and
# appropriate exclusions.
%pom_remove_dep org.sonatype.sisu:sisu-inject-plexus m2e-maven-runtime/org.eclipse.m2e.maven.indexer
%pom_add_dep org.eclipse.sisu:org.eclipse.sisu.plexus::provided m2e-maven-runtime/org.eclipse.m2e.maven.indexer

%pom_remove_dep org.sonatype.sisu.inject:guice-plexus-shim m2e-maven-runtime/org.eclipse.m2e.maven.runtime
%pom_add_dep org.eclipse.sisu:org.eclipse.sisu.inject m2e-maven-runtime/org.eclipse.m2e.maven.runtime "
    <exclusions>
      <exclusion>
        <groupId>com.google.inject</groupId>
        <artifactId>guice</artifactId>
      </exclusion>
    </exclusions>"

# Use Eclipse Aether
%pom_remove_dep org.sonatype.aether:aether-connector-wagon m2e-maven-runtime/org.eclipse.m2e.maven.runtime
%pom_add_dep org.eclipse.aether:aether-transport-wagon m2e-maven-runtime/org.eclipse.m2e.maven.runtime

%pom_remove_dep org.sonatype.aether:aether-impl m2e-maven-runtime/org.eclipse.m2e.maven.runtime
%pom_add_dep org.eclipse.aether:aether-impl m2e-maven-runtime/org.eclipse.m2e.maven.runtime

%pom_remove_dep org.sonatype.aether:aether-connector-asynchttpclient m2e-maven-runtime/org.eclipse.m2e.maven.runtime
%pom_add_dep org.eclipse.aether:aether-transport-http m2e-maven-runtime/org.eclipse.m2e.maven.runtime

%pom_add_dep org.eclipse.aether:aether-connector-basic m2e-maven-runtime/org.eclipse.m2e.maven.runtime

find -name *.java -exec sed -i -e "s/org.sonatype.aether/org.eclipse.aether/g" {} \;

sed -i -e "s/org.sonatype.aether/org.eclipse.aether/g" m2e-maven-runtime/org.eclipse.m2e.maven.runtime/pom.xml

# Don't add version to jar names that get bundled - easier for symlinking
pushd m2e-maven-runtime
  for pom in `find -name pom.xml`; do
    sed -i -e 's|</Embed-Dependency>|</Embed-Dependency><Embed-StripVersion>true</Embed-StripVersion>|g' ${pom};
  done
popd

%pom_xpath_inject pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration/pom:instructions/pom:Embed-Dependency \
    "maven-invoker,archetype-descriptor," m2e-maven-runtime/org.eclipse.m2e.archetype.common
%pom_xpath_inject pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration/pom:instructions/pom:Require-Bundle \
    "org.apache.maven.archetype.catalog," m2e-maven-runtime/org.eclipse.m2e.archetype.common
%pom_xpath_inject pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration/pom:instructions/pom:Require-Bundle \
    "org.apache.maven.archetype.catalog," m2e-maven-runtime/org.eclipse.m2e.maven.indexer

# oro is jakarta-oro in Fedora
pushd m2e-maven-runtime/org.eclipse.m2e.archetype.common/
  sed -i -e 's/oro,/jakarta-oro,/g' pom.xml
popd

# Fix OSGI generation in pom.xml for MANIFEST.MF
pushd m2e-maven-runtime/org.eclipse.m2e.maven.runtime/
  sed -i -e 's/;bundle-version=\".*/,/g' \
         -e 's/org.slf4j.api,/slf4j.api/g' pom.xml

  # While we're here, re-allow aopalliance to be embedded in OSGi
  # and exclude plexus-container-default
  # and re-allow slf4j-api
  sed -i -e 's/\!aopalliance|/\!plexus-container-default|/g' \
         -e 's/|slf4j-api//' pom.xml

popd

# Fix incorrect bundle name and version for slf4j in manifests
find -name MANIFEST.MF \
 -exec sed -i -e 's|org.slf4j.api;bundle-version=\".*\"|slf4j.api|g' {} \;

sed -i '/setupDefaultFilters/ a setupMatchPatterns();' org.eclipse.m2e.core/src/org/eclipse/m2e/core/internal/builder/ResourceScanner.java

%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch12

rm org.eclipse.m2e.core/src/org/eclipse/m2e/core/internal/embedder/FilterRepositorySystemSession.java


%build
repo=localrepo
mvn-rpmbuild -f m2e-maven-runtime/pom.xml install -Dmaven.local.repo=${repo} -X -Dmaven.local.debug=true
mvn-rpmbuild install javadoc:aggregate -Dmaven.local.repo=${repo} -X -Dmaven.local.debug=true

%install
install -d -m 0755 %{buildroot}%{install_loc_plugins}
install -d -m 0755 %{buildroot}%{install_loc_features}
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}

# Install normal plugins as packed jars
for dir in `find -name target|grep -v feature|grep -v m2e-maven-runtime|grep -v lifecyclemapping`; do
  if [ -f ${dir}/*-SNAPSHOT.jar ]; then
    cp -p ${dir}/*-SNAPSHOT.jar %{buildroot}%{install_loc_plugins}
  fi
done

# Unpack the plugins from m2e-maven-runtime
for plug in maven.runtime maven.indexer archetype.common; do
  unzip -q -d %{buildroot}%{install_loc_plugins}/org.eclipse.m2e.${plug}-%{version}-SNAPSHOT \
    m2e-maven-runtime/org.eclipse.m2e.${plug}/target/*-SNAPSHOT.jar
done

unzip -q -d %{buildroot}%{install_loc_plugins}/org.eclipse.m2e.lifecyclemapping.defaults-%{version}-SNAPSHOT \
  org.eclipse.m2e.lifecyclemapping.defaults/target/*-SNAPSHOT.jar

# symlink existing jars
pushd %{buildroot}%{install_loc_plugins}
  %{__ln_s} %{_javadir}/async-http-client/async-http-client.jar
  %{__ln_s} %{_javadir}/netty.jar
  %{__ln_s} %{_javadir}/slf4j/api.jar slf4j-api.jar
  %{__ln_s} %{_javadir}/slf4j/nop.jar slf4j-nop.jar
  %{__ln_s} %{_javadir}/maven-archetype/archetype-catalog.jar
  %{__ln_s} %{_javadir}/maven-archetype/archetype-descriptor.jar
popd

# Replace bundled JARs with symlinks to system JARs using XMvn Subst.  This way
# there is no need to manually synchronize JAR lists between Maven and M2E when
# some Maven dependency changes.  All that needs to be done is rebuilding M2E.
pushd %{buildroot}%{install_loc_plugins}
  xmvn-subst -s org.eclipse.m2e.maven.runtime-%{version}-SNAPSHOT/ \
    org.eclipse.m2e.maven.indexer-%{version}-SNAPSHOT/ \
    org.eclipse.m2e.archetype.common-%{version}-SNAPSHOT/
popd

# Install main feature
unzip -q -d %{buildroot}%{install_loc_features}/org.eclipse.m2e.feature-%{version}-SNAPSHOT \
  org.eclipse.m2e.feature/target/org.eclipse.m2e.feature-%{version}-SNAPSHOT.jar

# Javadocs
rm -f target/site/apidocs/javadoc.sh
cp -rp target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}


%files
%{eclipse_dropins}/%{name}
%doc org.eclipse.m2e.core/about.html
%doc epl-v10.html LICENSE-2.0.txt

%files javadoc
%{_javadocdir}/%{name}
%doc epl-v10.html LICENSE-2.0.txt


%changelog
* Fri Jul 25 2014 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-12
- RHBZ#1123042: Embed slf4j-api in maven runtime

* Mon Jan 27 2014 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-11.1
- Fix for RHBZ#1015324: Failing to retrieve archetypes

* Sat Jan  4 2014 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.4.0-11
- Fully remove CGlib from Maven runtime bundle
- Exclude AOP version of Guice from Sisu dependencies
- Fix Sisu dependency scope

* Thu Jan 02 2014 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-10
- Revert removal of workaround for missing cglib and aopalliance

* Tue Dec 31 2013 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.4.0-9
- Remove workaround for rhbz#911365 (missing cglib and aopalliance)
- Add NOP SLF4J implementation JAR to classpath
- Use xmvn-subst to symlink JARs, resolves: rhbz#1020299

* Wed Dec 04 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-8
- Rebuild in Rawhide

* Wed Oct 02 2013 Roland Grunberg <rgrunber@redhat.com> - 1.4.0-7
- Fix bug with plexus-utils > 3.0.5.

* Tue Oct 01 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-6
- Add BR/R on aether-connector-basic in f20+

* Sun Sep 29 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-5
- Fixes for maven 3.1.0

* Sat Aug 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-4
- Bump release to rebuild in rawhide/f20

* Mon Aug 19 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-3
- Use Eclipse Sisu and Eclipse Aether
- Add patch for new maven-indexer

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Jun 25 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.4.0-1
- Update to latest upstream version 1.4.0

* Tue May 14 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.3.1-2
- Fix broken symbolic links on f19+
- Update Requires/BuildRequires

* Sun Apr 07 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.3.1-1
- Update to upstream version 1.3.1

* Wed Feb 20 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-7
- Bump release to test again in koji (previously broken deps)

* Mon Feb 18 2013 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.2.0-6
- Drop dependency on plexus-container-default
- Resolves: rhbz#912311

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 1.2.0-5
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Wed Jan 30 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-4
- Update min versions of eclipse and eclipse-emf

* Thu Jan 24 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-3
- Fix incorrect changelog entry dates.

* Tue Jan 22 2013 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-2
- Remove javadoc.sh file from javadoc subpackage.
- Fix URL for source0.

* Tue Dec 11 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-1
- Bump to a more sane release number

* Tue Dec 11 2012 Mikolaj Izdebski <mizdebsk@redhat.com> - 1.2.0-0.3
- Add javadoc subpackage
- Fix licensing

* Tue Dec 11 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-0.2
- Require org.apache.maven.archetype.descriptor in OSGi for m2e.core.

* Mon Dec 10 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.2.0-0.1
- Attempt update to upstream 1.2.0

* Mon Dec 10 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.1.0-4
- Force usage of sisu over plexus-containers for DefaultPlexusContainer.

* Thu Dec 06 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.1.0-3
- Add cglib and aopalliance as embedded dependencies.
- Use newer pom macro to add netty dependency.
- Add cglib and aopalliance as dependencies in org.eclipse.m2e.maven.runtime.
- Symlink catalog and descriptor jars from maven-archetype.
- Remove symlink to plexus-container-default.jar, fix sisu-guice.jar link.

* Fri Aug 10 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.1.0-2
- Fix sources.

* Sun Aug 05 2012 Gerard Ryan <galileo@fedoraproject.org> - 1.1.0-1
- Initial packaging.
